#!/bin/sh

awk '
# Modify X and Y to make a nicer map.  We turn the map upside down (since 
# North and South are relative and can be flipped) 
# Input: A Civilization IV map (WorldBuilderSave) file
# Output: The same file with the map turned upside down
# WARNING: This screws up rivers; use river.awk to fix

# We do not actually know the size; this script is hard-coded for extra-huge
# PerfectWorld maps
function Xm(x) {return 143-x} 
function Ym(y) {return 95-y} 

{
# Starting locations
if(/StartingX=([0-9]+), StartingY=([0-9]+)/) {
        x=$0;
        sub(/.*StartingX=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*StartingY=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tStartingX=" x ", StartingY=" y
        }
# Map tiles
if(/x=([0-9]+),y=([0-9]+)/) {
        x=$0;
        sub(/.*x=/,"",x);sub(/,.*/,"",x);
        y=$0;sub(/.*y=/,"",y);
        x = Xm(x);y = Ym(y);
        $0 = "\tx=" x ",y=" y
        }
# Print modified map
print
}'         
